#include "config.h"

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <curses.h>
#include <fcntl.h>
#include <math.h>
#include <malloc.h>
#include <signal.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/user.h>
#include <sys/time.h>
#include <pwd.h>
#include <asm/param.h>
#include <term.h>
#undef tab

#if HAVE_LIBPROC
#include <proc/readproc.h>
#include <proc/sysinfo.h>
#include <proc/devname.h>
#else
#include "../proc/readproc.h"
#include "../proc/sysinfo.h"
#include "../proc/devname.h"
#endif

#define PT_SIZE 5
#define ESC_STRETCH 6
#define OUTBUF_SIZE (32*getpagesize()*ESC_STRETCH + 8*getpagesize())

/* thanx to Lajos Pajtek for this */
#define PAGEDIV ((kb_main_total) >> (page_shift-10))

#define DEBUG 0

#define TTYC 6

#define START_ROW 0
#define START_COL 0
#define ROW_SPACE 1
#define COL_SPACE 8
#define MAX_ROW LINES - 2 * ROW_SPACE - START_ROW

#define NORMAL 0
#define REINIT -2
#define QUIT -1
#define MONITOR_REFRESH -7
#define MONITOR -6
#define LEFT -5

#define FUSER 1
#define FPID 2
#define FCPU 3
#define FMEM 4
#define FTTY 5
#define FNICE 6
#define FSTAT 7
#define FTIME 8

#define FNAME 9

#define FIELDS 10

int field_op_[FIELDS];
int fields_;
int *avfields_;
