#define TIME_LENGTH 12
#define PROC_FILLBUG 0x3f

typedef struct etime_s {

  char dd[240];
  char hh[3];
  char mm[3];
  char ss[3];

} etime_t;


typedef struct procinfo_s {
    struct procinfo_s *next;
    int uid;
    /*  char uname[10]; */

    proc_t *proc;
    char *pname;
    char *s_pname;

    etime_t etime;	
  char stime[TIME_LENGTH];
    
    char ttyc[TTYC];
    unsigned long pmem;
    int expand;
    int num_child;
    int is_selected;
    
} procinfo_t;

typedef struct tree_s {
    pid_t pid;
    int row;
    int col;
    int num_child;
    struct tree_s *parent;
    struct tree_s **children;
} tree;

/*  int t_row; */

typedef struct killer_s {
  
  int count;
  int t_count;
  int monitoring;
  /*  int user_count; */
  uid_t *uidlist;
  tree *ptree;

  procinfo_t *pidlist; 
  procinfo_t *trunk;
  struct killer_s *son;
  struct killer_s *mother;
} killer_t;

int t_view;


int template_size;
int *selection_template;

void initplist(killer_t *chow);
int find(killer_t *chow, int selected, char *input, int t_view);
void search(killer_t *mother, char *input, int t_view);
void get_lc(procinfo_t *input);
void fill_pcpu(proc_t *buf);
void after_spew(procinfo_t *tmp, int count);
void monitor(killer_t *mother);
int check_selection(int pid);
void refresh_stemplate(killer_t * mother);
void shell_sort(procinfo_t *pidlist, int crit, int count);
int pid_pos(pid_t pid, procinfo_t *pidlist, int count);
long alpha(char *string1, char *string2);
void dup_procinfo_t(procinfo_t *target, procinfo_t *orig);
void free_list(procinfo_t *pidlist, int count);
